require_relative "io"

module Ascode
  module Interpreter
    class Environment
      attr_accessor :ast, :stack, :register

      def initialize(ast = "")
        @ast = ast
        @stack = []
        @register = nil
      end

      def push(what)
        @stack.push what
      end

      def reg_copy
        @register = pop
      end

      def reg_paste
        push @register
      end

      def pop(ask = true)
        value = @stack.pop
        if value
          value
        elsif ask
          IO.input itself
          @stack.pop
        end
      end

      def swap
        a = pop false
        b = pop false
        push a
        push b
      end

      def duplicate
        a = pop
        push a
        push a
      end
    end
  end
end