require_relative "environment"
require_relative "condition"
require_relative "math"
require_relative "io"

module Ascode
  module Interpreter
    class Main
      def initialize(ast, env = Environment.new)
        @env = env
        @env.ast = ast

        @map = {
          io: IO,
          math: Math,
          condition: Condition
        }
      end

      def run
        @env.ast.each do |action|
          name = action[:action]

          if name == "push"
            @env.push(action[:what])
          elsif name == "condition"
            Condition.begin @env, action[:true_block], action[:false_block]
          else
            call action[:type], name
          end
        end
      end

      def call(type, name)
        if type == :env
          @env.send name
        else
          @map[type].send name, @env
        end
      end
    end
  end
end
