module Ascode
  module Interpreter
    class Math
      def self.plus(env)
        a = env.pop
        b = env.pop
        env.push a + b
      end

      def self.minus(env)
        a = env.pop
        b = env.pop
        env.push a - b
      end

      def self.divide(env)
        a = env.pop
        b = env.pop
        env.push a / b
      end

      def self.multiply(env)
        a = env.pop
        b = env.pop
        env.push a * b
      end

      def self.increment(env)
        a = env.pop
        env.push a + 1
      end

      def self.decrement(env)
        a = env.pop
        env.push a - 1
      end

      def self.bigger_than(env)
        a = env.pop
        b = env.pop
        env.push a > b ? 1 : 0
      end

      def self.less_than(env)
        a = env.pop
        b = env.pop
        env.push a < b ? 1 : 0
      end

      def self.equal(env)
        a = env.pop
        b = env.pop
        env.push a == b ? 1 : 0
      end

      def self.even(env)
        env.push env.pop.even? ? 1 : 0
      end

      def self.invert(env)
        a = env.pop
        if a.zero?
          env.push 1
        else
          env.push 0
        end
      end

      def self.change_sign(env)
        env.push(-1 * env.pop)
      end
    end
  end
end
