module Ascode
  module Parser
    class Function
      def parse(char)
        CODE.find do |type|
          type[1].find do |function|
            @ast = ast type[0], function[1] if function[0] == char
          end
        end

        return unless @ast
        @ast
      end

      def ast(type, name)
        {
          type: type,
          action: name
        }
      end

      CODE = {
        io: [
          %w[I input],
          %w[O output],
          %w[N new_line]
        ],

        env: [
          %w[P pop],
          %w[C reg_copy],
          %w[V reg_paste],
          %w[S swap],
          %w[D duplicate]
        ],

        condition: [
          %w([ begin),
          %w[: else],
          %w(] end)
        ],

        math: [
          %w[+ plus],
          %w[- minus],
          %w[* multiply],
          %w[/ divide],
          %w[i increment],
          %w[d decrement],
          %w[> bigger_than],
          %w[< less_than],
          %w[= equal],
          %w[e even],
          %w[! invert],
          %w[s change_sign]
        ]
      }.freeze
    end
  end
end
