require_relative "../converter"

module Ascode
  module Parser
    class Literal
      attr_reader :length

      def initialize(code, literal_begin)
        @code = code
        @begin = literal_begin
      end

      def parse
        @quoted = @code[@begin] == '"'
        @begin += 1 if @quoted
        @literal = @code[@begin..-1]

        @end = find_end
        @literal = @literal[0..(@end - 1)]

        @literal = Converter.convert @literal
        @length = @literal.to_s.length + (@quoted ? 1 : -1)
        ast
      end

      def find_end
        escape = false
        @literal.split("").each_with_index do |char, index|
          if @quoted
            return index if char == '"' && !escape
            escape = char == "\\"
          else
            return index unless char =~ /[0-9.]/
          end
        end
        -1
      end

      def ast
        @ast = {
          action: "push",
          what: @literal
        }
      end
    end
  end
end
